#!/usr/bin/perl
#               -------------
#               Plebius! Webtools
#               -------------
#           Set of internet utilities
#
#         File: output.cgi	
#  Description: Parse input and display output
#       Author: Martin Kretzmann
#        Email: martin@plebius.org
#          Web: http://www.plebius.org
#      Version: 2.0
#  Copyright : 1999-2000 Martin Kretzmann.  All Rights Reserved.
#      License: GNU General Public License. 
#               http://www.plebius.org/cgi-bin/article.pl?aid=000063
#
#====================================================================

# write all requests to a log file? (0 = no, 1 = yes);
$log_requests = 1;

# contents of body tag
$body = qq~body bgcolor="#FFFFFF" text="#000000" link="#336699" alink="#FFFFFF" vlink="#990033"~;

# use full HTTP headers? Only if your server requires it. (0 = no, 1 = yes)
$use_full_headers = 0;

# names of the files
%filenames = (
'Whois'      => 'whois.pl',
'Finger'     => 'finger.pl',
'DNS query'  => 'dnsquery.pl',
'NS lookup'  => 'nslookup.pl',
'Ping'       => 'ping.pl',
'HTTP'       => 'HTTP.pl',
'Host'       => 'host.pl',
'Traceroute' => 'traceroute.pl',
'output'     => 'output.cgi'
             );

#====================================================================

$aaa = $filenames{'output'};
if ($ENV{'SCRIPT_NAME'} =~ /$aaa$/m)
{
$form = '
      <script language="Javascript">
      <!--
      function GoTo(){
               tool     = document.ToolForm.toolselect.options[document.ToolForm.toolselect.selectedIndex].value
               query    = document.ToolForm.input.value
               if(query == \'\')
               { 
                  return
               }
               else
               { 
                  location = tool + query
               }
      }
      //-->
      </script>
      <form name=ToolForm method=GET action="javascript:GoTo()">
      <font face="arial,helvetica" size=2>
      Plebius Webtools!<br>
      <select name="toolselect">
      ';
  foreach $key(keys(%filenames))
  {
         unless ($key eq 'output')
         {
                 $form .= "<option value=\"$filenames{$key}?\">$key";
         }
  }
  $form .= '
  </select>
  <input name="input"><input type=button value="Submit Query" onClick="GoTo()">
  </font>
  </form>
  ';
   &show();
}

sub data_parse{
    my ($query, $action);  
    if ($ENV{'REQUEST_METHOD'} eq 'POST')
    {
       read(STDIN, $query, $ENV{'CONTENT_LENGTH'});
       $query =~ /action=([^\&]*)\&/;
       $action = $1;
       $query =~ s/action=([^\&]*)\&//g;
       $query =~ s/input=//g;
       $query =~ tr/+/ /;
       $query =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    }
    else
    {
       $query = $ENV{'QUERY_STRING'};
    }
    $query =~ s/[ ;\[\]\<\>&\$\*\?\(\)\|\{\}\\\'\"\`\~\!]//g; 
    $query =~ s/\s+//ig;
    &show('','','','','Enter you query ','') if ($query eq '');
    return ($query, $action);
}

sub gettime{
	($Second, $Minute, $Hour, $DayOfMonth, $Month, $Year,$WeekDay, $DayOfYear, $IsDST) = localtime(time);
        $DateAndTime = sprintf("%02d:%02d:%02d" ,$Hour, $Minute,$Second);
	return($DateAndTime);
}

sub show{
	local($start,$stop,$command,$query,$output,$special) = @_;

        # write to log
        if ($log_requests)
        {
          open(FILE, ">>log.txt");
          print FILE "$special|$query\n";
          close(FILE);
        }

        print "HTTP/1.0 200 OK\n" if ($use_full_headers);
	print "Content-Type: text/html\n";

        $form = qq~<FORM ACTION="$ENV{'SCRIPT_NAME'}" method=POST><INPUT NAME="input" value="$query"><input type=submit></form>~ unless ($form);
        # remove HTML from $output
        $output =~ s/</&lt;/g;
	$output =~ s/>/&gt;/g;
	$HTML   = qq~
<html>
<head>
<title>Plebius Webtools</title>
</head>
<$body>
<center>
<table width=600 cellpadding=6 cellspacing=6><tr><td>
<font face="arial,helvetica" size=2>
~;
        $HTML .= "Input Query: $query<br>" if ($query);
	$HTML .= "Started at: $start<br>\n" if ($start);
	$HTML .= "Stopped at: $stop<br>\n" if ($stop);
        if ($special =~ /Whois/)
        {
          if ($query =~ /\.uk/)
          {
           $HTML .= qq~<p>Click <a href="http://www.commission-junction.com/track/track.dll?AID=54200&PID=233417&URL=http%3A%2F%2Fwww%2Eallukdomains%2Eco%2Euk%2F">here</a> to register $input now.<img src="http://www.commission-junction.com/banners/tracker.exe?AID=54200&PID=233417&banner=0.gif" height=1 width=1 border=0><p>~;
          }
          elsif($query =~ /\.(com|net|org|au|nz|uk|za|ac|as|cc|ch|cx|dk|il|li|it|ro|to)/)
          {
           $HTML .= qq~<p><a href="http://www.commission-junction.com/track/track.dll?AID=59067&PID=233417&URL=http%3A%2F%2Fwww%2Eregistryweb%2Ecom%2F">Register Discount Domain Names at RegistryWeb</a><img src="http://www.commission-junction.com/banners/tracker.exe?AID=59067&PID=233417&banner=0.gif" height=1 width=1 border=0><p>~;
          }
        }
	$HTML .= "<pre>$output</pre>\n" if ($output);
        $HTML .= $form;
        $HTML .= qq~<!-- this line of code may not be removed upon penalty of death--><p align=center><small>Powered by <a href="http://www.plebius.org/">Plebius! Webtools 2.0</a></small></p>~;
	$HTML .= qq~
</font>
</td></tr></table>
</center>
</body></html>
~;

    print $HTML;
    exit;
}


1;